/*
 * segatex SELinux tool.
 *
 * Copyright (C) 2007-2014 Shintaro Fujiwara 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * */

#ifndef AUTORELABEL_H
#define AUTORELABEL_H

#include <QDialog>
#include <QLayout>
#include <QRadioButton>
#include <Q3ButtonGroup>
#include <QDir> 
#include <QRegExp> 
#include <QLabel> 
#include <QTextEdit>
#include <QVBoxLayout>
#include <QHBoxLayout>


class QLayout;
class QTextEdit;
class QLineEdit;
class QPushButton;

class AutoRelabel: public QDialog 
{
	Q_OBJECT
public:
	AutoRelabel(QWidget *parent = 0, const char *name = 0);
public slots:
signals:
protected:
private slots:
	void autorelabel_base_process();
	void autorelabel_button_clicked();
	void autorelabel_button_clicked_process();
	void readFromOutputFile();
public:
private:
	Q3ButtonGroup *timeButtonGroup;
	QPushButton *autorelabelButton;
	QPushButton *closeButton;
        QRadioButton *nowRadioButton;
        QRadioButton *nextbootRadioButton;
	QTextEdit *textEdit1;

	QVBoxLayout *mainLayout;
	QVBoxLayout *upperLayout;
	QVBoxLayout *underLayout;
	QHBoxLayout *leftLayout;
	QHBoxLayout *rightLayout;
	QHBoxLayout *thirdLayout;
	QVBoxLayout *middleLayout;
	QHBoxLayout *footLayout;

        QDir dir;
        QString path;
        QString name;
        QString dir_name;
        QString forward_slash;
        QString file_interface_name;
        QString line_analized;
        QString outputfile_str;

        QStringList::Iterator it_d;
        QStringList files;

        QString radiobutton_obj_str;
        QLabel *semanageEditLabel;
        QLabel *semanageEditLabel2;
        QLineEdit *semanageEditLineEdit;
        QLineEdit *semanageEditLineEdit2;
        QString semanageEditLineEdit_str;
        QString semanageEditLineEdit2_str;
        QString semanageEditLineEdit_str_pp;
};

#endif
